////////////////////////////////////////////////////////////////////// 
// clusters/Unknown.cpp 
// (c) 2000-2005 Goncalo Abecasis
// 
// This file is distributed as part of the MERLIN source code package   
// and may not be redistributed in any form, without prior written    
// permission from the author. Permission is granted for you to       
// modify this file for your own personal use, but modified versions  
// must retain this copyright notice and must not be distributed.     
// 
// Permission is granted for you to use this file to compile MERLIN.    
// 
// All computer programs have bugs. Use this file at your own risk.   
// 
// Monday December 12, 2005
// 
 
#include "Unknown.h"

MissingAllele * SetOfUnknowns::GetMissing(const ::String & name)
   {
   return (MissingAllele *) objects[Find(name, create_missing)];
   }

AlleleGraph * SetOfUnknowns::GetGraph(const ::String & name)
   {
   return (AlleleGraph *) objects[Find(name, create_graph)];
   }

void * SetOfUnknowns::create_missing()
   {
   return new MissingAllele;
   }

void * SetOfUnknowns::create_graph()
   {
   return new AlleleGraph;
   }

SetOfUnknowns::~SetOfUnknowns()
   {
   for (int i = 0; i < Length(); i++)
      delete (Unknown *) objects[i];
   }



 
